Redmine - Defect #35726

Time Formatting does not apply to CSV exports
2021-08-09 18:25 - salman mp

Status: Confirmed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Time tracking Estimated time: 0.00 hour
Target version: 6.1.0

Resolution: Affected version: 3.4.0
Description

When you export time report to CSV, formatting does not apply on hours field.
Attached patch can fixed it.

Related issues:

Related to Redmine - Feature #23996: Introduce a setting to change the displa... Closed
Related to Redmine - Defect #31637: CSV and PDF export don't respect Time spa... Confirmed
History

#1 - 2021-08-09 21:45 - Mischa The Evil

- File #35726.patch added

- Subject changed from Time Formatting does not apply in time reports export to Time Formatting does not apply to CSV exports
- Category deleted (Time tracking)
- Status changed from New to Confirmed

- Affected version changed from 4.2.2 to 3.4.0

Nice catch! However, this does not only apply to the CSV export of the timelog report. It also applies to CSV exports of:

e timelog details;
e issue lists.

I'll leave a patch containing:

¢ the OP's initial changes, in a correct format;
e an additional change of QueriesHelper#csv_value to fix the issue for CSV exports of timelog details and issue lists.

I'll set the category to 'none' because it applies not only to 'Time tracking' and we don't have a CSV export category yet (and | don't want [to consider]
to create it now).

I'll set the affected version to '3.4.0' because the issue was introduced with #23996. The fixes have to be back-ported to all supported Redmine
branches.

I think that before this is being committed additional test coverage should be added for the fixed cases.

#2 - 2021-08-09 21:46 - Mischa The Evil
- Related to Feature #23996: Introduce a setting to change the display format of timespans to HH:MM added

#3 - 2021-08-10 12:17 - Holger Just

| don't think we should backport this to older versions.

The CSV export emits a technical format which is usually consumed by spreadsheet software, or custom reporting tools. ere, it is important not to
change the output format without consideration. As the output of the hours have always been floats here, consuming software likely expects this.
Changing this in a patch update will likely break the assumptions of these tools unexpectedly.

As such, | believe we may ship this in 5.0.0 as a potentially breaking change and not backport it.

#4 - 2021-08-11 08:23 - Mischa The Evil

Good point. Fair enough. FYI, I'm also ok with no back-ports like you propose. My comment was more about the Redmine releases that are affected
by this defect, and as such can be qualified as eligible for receiving the back-ports.

Nonetheless, | don't think that back-porting the fixes would become troublesome for the users in this case because:
https://www.redmine.org/issues/23996
https://www.redmine.org/versions/155

Holger Just wrote:

[...] As the output of the hours have always been floats here, consuming software likely expects this. Changing this in a patch update will likely

break the assumptions of these tools unexpectedly.

... this is not what these fixes would actually do IMHO. They don't change the output format of hours. Instead, slightly more subtle, they change the
applicability of the setting that should determine the desired output format of the hours values.
Now, given that the default value of the setting is (still) to output floats (i.e. 'decimal’), nothing would change unless the administrator itself explicitly
configured the Redmine instance to do so (i.e. by changing the setting to 'minutes’). And in that case it is/would be an anomaly to detect that only the
CSV exports don't obey this setting (given that #23996 states: "a setting to also display such values in this way throughout the app"). And by then we

can "argue" over whether "throughout the app" actually applies to CSV exports created by 'the app'... :lol: I'd say it does... :grin:

#5 - 2022-01-19 22:44 - Go MAEDA

- Related to Defect #31637: CSV and PDF export don't respect Time span format added

#6 - 2022-01-19 22:45 - Go MAEDA

- Category set to Time tracking

#7 - 2023-11-29 10:21 - Mischa The Evil

- Target version set to 6.0.0

This might be the time to schedule this (and by extension #31637).

#8 - 2024-11-03 19:53 - Marius BALTEANU

- Target version changed from 6.0.0 to 6.1.0

This change still needs some work.

Files
timelog_helper.patch 1.27 KB 2021-08-09 salman mp
#35726.patch 1.66 KB 2021-08-09 Mischa The Evil
